.486
.model flat,stdcall
option	casemap:none

includelib  \masm32\lib\kernel32.lib
includelib 	\masm32\lib\user32.lib
includelib 	\masm32\lib\masm32.lib
includelib 	\masm32\lib\debug.lib
include 	\masm32\include\windows.inc
include 	\masm32\include\kernel32.inc
include 	\masm32\include\user32.inc
include 	\masm32\include\masm32.inc
include 	\masm32\include\debug.inc
includelib	iphlpapi.lib
include		iphlpapi.inc

StdTextOut	 PROTO	STDCALL :DWORD, :DWORD
StdItemOut	 PROTO	STDCALL :DWORD, :DWORD, :DWORD
StdIPListOut PROTO 	STDCALL :DWORD, :DWORD

.data?
hInstance		dd	?

fakeBuffer		dd	?
lenBuffer		dd	?
pAdapterBuffer	dd	?
curAdapter		dd	?
tempBuffer		db  16 dup (?)

hStdOut			dd	?
.data

adapterTypeList	dd		offset adapterType0, offset adapterType1
				dd		offset adapterType2, offset adapterType3
				dd		offset adapterType4, offset adapterType5
				dd		offset adapterType6, offset adapterTypeUN

adapterType0	db		"Other",0
adapterType1	db		"Ethernet",0
adapterType2	db		"Token ring",0
adapterType3	db		"FDDI",0
adapterType4	db		"PPP",0
adapterType5	db		"Loopback",0
adapterType6	db		"SLIP",0
adapterTypeUN	db		"Unknown",0

outNextLine		db	0Dh,0Ah,0
out2NextLines	db	0Dh,0Ah,0Dh,0Dh,0Ah,0
outHeader1		db	"   _________________________"
outHeader2		db	"__/ Adapter ",0
outHeader3		db	" \________________________________________________________________"

outAdapterName	db	"  Adapter name:",0dh,0ah,0
outAdapterDesc	db	"  Adapter description:",0dh,0ah,0
outHardwareAddr db	"  Hardware address:",0dh,0ah,0
outType			db	"  Type:",0dh,0ah,0
outDHCPEnabled	db	"  DHCP Enabled:",0dh,0ah,0
outCurIPAddr	db	"  Current IP address:",0dh,0ah,0
outIPList		db	"  IP address list:",0dh,0ah,0
outGatewayList	db	"  Gateway list:",0dh,0ah,0
outDHCPServer	db	"  DHCP Server:",0dh,0ah,0
outUsesWINS		db	"  Uses WINS:",0dh,0ah,0
outPrimWINS		db	"    Primary WINS server:   ",0
outSecWINS		db	"    Secondary WINS server: ",0

itemIndent		db	"    "

outYes			db	"Yes",0
outNo			db	"No",0
;-----------------------------------------------------------------------------
; Code
;-----------------------------------------------------------------------------
.code
start:
	invoke	GetModuleHandle, NULL
	mov		hInstance, eax
	
	invoke	GetStdHandle, STD_OUTPUT_HANDLE	
	mov		hStdOut, eax
	
	
	; --- Read adapter info with fake buffer of 1 byte (to determine size) ---
	mov		lenBuffer, 1
	invoke	GetAdaptersInfo, addr fakeBuffer, addr lenBuffer
	.IF		eax==ERROR_NO_DATA
		jmp		@no_data
	.ELSEIF	eax==ERROR_BUFFER_OVERFLOW
		; allocate memory for real buffer:
		invoke	GlobalAlloc, GMEM_FIXED or GMEM_ZEROINIT, lenBuffer
		mov		pAdapterBuffer, eax
	.ELSE
		jmp		@error
	.ENDIF
	
	; --- Get adapter info in real buffer ---
	invoke	GetAdaptersInfo, pAdapterBuffer, addr lenBuffer
	.IF		eax==ERROR_NO_DATA
		jmp		@no_data
	.ELSEIF eax!=ERROR_SUCCESS
		jmp		@error
	.ENDIF
	
	; --- Walk through linked list of adapter info structs ---
	mov		curAdapter, 1
	mov		edi, pAdapterBuffer
	assume	edi:PTR IP_ADAPTER_INFO
	.WHILE	edi
	
		; --- Print adapter header ---
		invoke	dwtoa, curAdapter, addr tempBuffer
		invoke	StrLen, addr tempBuffer
		add		eax, 13
		mov		ebx, eax

		invoke	StdTextOut, addr outHeader1, eax
		invoke	StdTextOut, addr outNextLine,0
		invoke	StdTextOut, addr outHeader2, 0
		invoke	StdTextOut, addr tempBuffer, 0 
		neg		ebx
		add		ebx, 80
		invoke	StdTextOut, addr outHeader3, ebx
		invoke	StdTextOut, addr out2NextLines, 0


		invoke	StdItemOut, addr outAdapterName, addr [edi].AdapterName, 0
		
		; trim right part of description. there tend to be spaces
		; at the end of the description...
		invoke	StrLen, addr [edi].Description
		lea		ecx, [edi].Description
		lea		edx, [edi].Description
		add		ecx, eax
		.WHILE	ecx>=edx
			mov		al, [ecx]
			.BREAK .IF	al!=" " && al!=09 && al!=0
			mov		byte ptr [ecx], 0
			dec		ecx
		.ENDW
		
		invoke	StdItemOut, addr outAdapterDesc, addr [edi].Description, 0
		
		
;		!!!!!!!!!!
;		
;		  AddressLength		dd		?
;    Address				db		MAX_ADAPTER_ADDRESS_LENGTH dup (?)
    
		mov		eax, [edi].uType
		.IF		eax>6
			mov		eax, 7 ;unknown
		.ENDIF
		mov		eax, [offset adapterTypeList + 4 * eax]
		invoke	StdItemOut, addr outType, eax, 0
		
		mov		ecx, offset outNo
		.IF [edi].DhcpEnabled
			mov		ecx, offset outYes
		.ENDIF
		invoke	StdItemOut, addr outDHCPEnabled, ecx, 0
		
		
		mov		eax, [edi].CurrentIpAddress
		.IF		eax
			invoke	StdItemOut, addr outCurIPAddr, addr (IP_ADDR_STRING ptr [eax]).IpAddress, 0
		.ENDIF
		
		invoke	StdIPListOut, addr outIPList, addr [edi].IpAddressList
		
		invoke	StdIPListOut, addr outGatewayList, addr [edi].GatewayList
		.IF [edi].DhcpEnabled
			invoke	StdIPListOut, addr outDHCPServer, addr [edi].DhcpServer
		.ENDIF
		
		mov		ecx, offset outNo
		.IF [edi].HaveWins
			mov		ecx, offset outYes
		.ENDIF
		invoke	StdItemOut, addr outUsesWINS, ecx, 0
		
		.IF	[edi].HaveWins
			invoke	StdIPListOut, addr outPrimWINS, addr [edi].PrimaryWinsServer
			invoke	StdIPListOut, addr outSecWINS, addr [edi].SecondaryWinsServer
		
		.ENDIF
		
		invoke	StdTextOut, addr outNextLine,0

		mov		edi, [edi].Next
		inc		curAdapter
	.ENDW
	assume edi:nothing
	
	invoke	GlobalFree, pAdapterBuffer
	@no_data:
	
	@error:

   	invoke	ExitProcess, NULL
 
 
StdIPListOut proc uses esi	lpTitle:DWORD, lpIPAddrString:DWORD
		invoke	StdTextOut, lpTitle, 0
		
		mov		esi, lpIPAddrString
		assume	esi:ptr IP_ADDR_STRING
		.WHILE	esi
			invoke	StdTextOut, addr itemIndent, 4
			invoke	StdTextOut, addr [esi].IpAddress, 0
			invoke	StdTextOut, addr outNextLine, 0
			mov		esi, [esi].Next
		.ENDW
		assume	esi:nothing
ret
StdIPListOut endp
;--------------------------------------------------------------------
; StdItemOut
;--------------------------------------------------------------------
StdItemOut proc lpTitle, lpData:DWORD, lnData:DWORD
LOCAL	BytesWritten:DWORD
	invoke	StdTextOut, lpTitle, 0
	invoke	StdTextOut, addr itemIndent, 4
	invoke	StdTextOut, lpData, lnData
	invoke	StdTextOut, addr outNextLine, 0
	ret
StdItemOut endp

   	
  	
;--------------------------------------------------------------------
; StdTextOut
;--------------------------------------------------------------------
StdTextOut proc lpData:DWORD, lnData:DWORD
LOCAL	BytesWritten:DWORD
	mov		ecx, lnData
	.IF		!ecx
		invoke	StrLen, lpData
		mov		ecx, eax
	.ENDIF
	invoke	WriteFile, hStdOut, lpData, ecx, addr BytesWritten, NULL
	ret
StdTextOut endp


end start 